               ORG &100
; *****************************************************************************
; * The Music Studio Player Engine
; *
; * Based on code written by Saa Puica for the utility, The Music Studio.
; * Modified by Chris Cowley
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************

beep_on equ 11
beep_off equ 12
beep_xor equ beep_on xor beep_off
beep_port equ &f8
START:
di

ld a,4			;; disconnect fdc interrupt
out (&f8),a
ld a,5			;; set terminal count
out (&f8),a
ld a,6			;; clear terminal count
out (&f8),a
ld a,10			;; turn off disc motor
out (&f8),a	
                          LD    HL,MUSICDATA         ;  <- Pointer to Music Data. Change
                                                     ;     this to play a different song
                          LD   A,(HL)                         ; Get the loop start pointer
                          LD   (PATTERN_LOOP_BEGIN),A
                          INC  HL
                          LD   A,(HL)                         ; Get the song end pointer
                          LD   (PATTERN_LOOP_END),A
                          INC  HL
                          LD   (PATTERNDATA1),HL
                          LD   (PATTERNDATA2),HL
                          LD   A,254
                          LD   (PATTERN_PTR),A                ; Set the pattern pointer to zero
                          ;;DI
                          ;;EXX
                          ;;PUSH  HL
                          CALL  NEXT_PATTERN
NEXTNOTE:
                          CALL  PLAYNOTE
		
						;; input check removed.
						  defs 8
							jp NEXTNOTE

                          ;;POP   HL
                          ;;EXX                                 ; Restore HL' for return to BASIC
                        
				ld a,3			;; connect fdc interrupt to int
				out (&f8),a
				
				ld a,beep_off
				out (beep_port),a

						  EI
                          RET                                 ; Return from playing tune

PATTERN_PTR:              DEFB 0
NOTE_PTR:                 DEFB 0

; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************
NEXT_PATTERN:
                          LD   A,(PATTERN_PTR)
                          INC  A
                          INC  A
                          DEFB $FE                           ; CP n
PATTERN_LOOP_END:         DEFB 0
                          JR   NZ,NO_PATTERN_LOOP
                          DEFB $3E                           ; LD A,n
PATTERN_LOOP_BEGIN:       DEFB 0
NO_PATTERN_LOOP:          LD   (PATTERN_PTR),A

			                    DEFB $21                            ; LD HL,nn
PATTERNDATA1:             DEFW $0000
                          LD   E,A                            ; (this is the first byte of the pattern)
                          LD   D,0                            ; and store it at TEMPO
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)
                          LD   A,(DE)                         ; Pattern Tempo -> A
	                	      LD   (TEMPO),A                      ; Store it at TEMPO

                          LD   A,1
                          LD   (NOTE_PTR),A

PLAYNOTE: 
                          DEFB $21                            ; LD HL,nn
PATTERNDATA2:             DEFW $0000
                          LD   A,(PATTERN_PTR)
                          LD   E,A
                          LD   D,0
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)                         ; Now DE = Start of Pattern data
                          LD   A,(NOTE_PTR)
                          LD   L,A
                          LD   H,0
                          ADD  HL,DE                          ; Now HL = address of note data
                          LD   D,(HL)
                          LD   E,1

; IF D = $0 then were at the end of the pattern so increment PATTERN_PTR by 2 and set NOTE_PTR=0
                          LD   A,D
                          CP   $FE                           ; $FE indicates end of pattern
                          JR   Z,NEXT_PATTERN

CONTINUE0:                PUSH DE
                          INC  HL
                          LD   D,(HL)
                          LD   E,1

                          LD   A,(NOTE_PTR)
                          INC  A
                          INC  A
                          LD   (NOTE_PTR),A                   ; Increment the note pointer by 2 (one note per chan)

                          EXX
                          POP  DE                             ; Now CH1 freq is in DE, and CH2 freq is in DE'

                          LD   A,(TEMPO)
                          LD   C,A
                          LD   B,0
                          LD   A,beep_off
                          EX   AF,AF'
                          LD   A,beep_off                  ; So now BC = TEMPO, A and A' = BORDER_COL
                          EXX

OUTPUT_NOTE:
                          LD   IXH,D                          ; Put note frequency for chan 1 into IXH
                          LD   H,D
                          LD   L,H
                          DEC  L
                          LD   E,L
                          JR   Z,CONTINUE1
                          LD   E,beep_xor
CONTINUE1:
                          EXX
                          LD   IXL,D                          ; Put note frequency for chan 2 into IXL
                          LD   H,D
                          LD   L,H
                          DEC  L
                          LD   E,L
                          JR   Z,CONTINUE2
                          LD   E,beep_xor
CONTINUE2:
                          EXX
                          EX   AF,AF'
                          OUT  (beep_port),A
                          DEC  H             ; Dec H, which also holds the frequency value
                          JR   NZ,L8055
                          XOR  E
                          LD   H,D
                          PUSH AF
                          LD   A,IXH
                          CP   $20
                          JR   NC,L8054      ; if A > $20 then this is not a drum effect, skip the INC D
                          INC  D             ; create the "fast falling pitch" percussion effect
L8054:                    POP  AF
L8055:                    DEC  L
                          JR   NZ,L805B
                          XOR  E
                          LD   L,D
                          DEC  L
L805B:                    EXX
                          EX   AF,AF'
                          OUT  (beep_port),A
                          DEC  H
                          JR   NZ,L806D
                          XOR  E
                          LD   H,D
                          PUSH AF
                          LD   A,IXL
                          CP   $20
                          JR   NC,L806C     ; if A > $20 then this is not a drum effect, skip the INC D
                          INC  D            ; create the "fast falling pitch" percussion effect
L806C:                    POP  AF
L806D:                    DEC  L
                          JR   NZ,L8073
                          XOR  E
                          LD   L,D
                          DEC  L
L8073:                    DJNZ CONTINUE2
                          DEC  C
                          JR   NZ,CONTINUE2
                          RET

; *** DATA ***
;; border colour not required. removed.
TEMPO:                    DEFB 242

MUSICDATA:
                    DEFB 0   ; Loop start point * 2
                    DEFB 34   ; Song Length * 2
PATTERNDATA:        DEFW      PAT0
                    DEFW      PAT1
                    DEFW      PAT2
                    DEFW      PAT3
                    DEFW      PAT4
                    DEFW      PAT5
                    DEFW      PAT6
                    DEFW      PAT6
                    DEFW      PAT7
                    DEFW      PAT8
                    DEFW      PAT9
                    DEFW      PAT9
                    DEFW      PAT10
                    DEFW      PAT11
                    DEFW      PAT12
                    DEFW      PAT13
                    DEFW      PAT14

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $FE to
; *** Mark the end of the pattern, and $01 for a rest
PAT0:
         DEFB 16  ; Pattern tempo
             DEFB 76,16
             DEFB 114,227
             DEFB 1,0
             DEFB 114,227
             DEFB 1,227
             DEFB 1,227
             DEFB 114,0
             DEFB 1,227
             DEFB 1,192
             DEFB 96,192
             DEFB 1,0
             DEFB 1,192
             DEFB 86,171
             DEFB 1,171
             DEFB 76,0
             DEFB 1,171
         DEFB $FE
PAT1:
         DEFB 16  ; Pattern tempo
             DEFB 1,16
             DEFB 114,227
             DEFB 1,0
             DEFB 1,227
             DEFB 114,227
             DEFB 1,227
             DEFB 114,0
             DEFB 1,227
             DEFB 1,192
             DEFB 96,192
             DEFB 1,0
             DEFB 1,192
             DEFB 114,171
             DEFB 1,171
             DEFB 128,0
             DEFB 121,171
         DEFB $FE
PAT2:
         DEFB 16  ; Pattern tempo
             DEFB 1,16
             DEFB 86,227
             DEFB 1,0
             DEFB 1,227
             DEFB 86,227
             DEFB 1,227
             DEFB 76,0
             DEFB 1,227
             DEFB 1,192
             DEFB 114,192
             DEFB 1,0
             DEFB 1,192
             DEFB 114,171
             DEFB 1,171
             DEFB 128,0
             DEFB 121,171
         DEFB $FE
PAT3:
         DEFB 16  ; Pattern tempo
             DEFB 1,16
             DEFB 76,227
             DEFB 1,0
             DEFB 1,227
             DEFB 76,227
             DEFB 1,227
             DEFB 76,0
             DEFB 1,227
             DEFB 1,192
             DEFB 86,192
             DEFB 1,0
             DEFB 1,192
             DEFB 96,171
             DEFB 114,171
             DEFB 128,0
             DEFB 114,171
         DEFB $FE
PAT4:
         DEFB 16  ; Pattern tempo
             DEFB 1,16
             DEFB 227,30
             DEFB 1,0
             DEFB 227,30
             DEFB 227,1
             DEFB 227,1
             DEFB 1,30
             DEFB 227,1
             DEFB 192,30
             DEFB 192,1
             DEFB 1,0
             DEFB 192,30
             DEFB 171,1
             DEFB 171,1
             DEFB 1,30
             DEFB 171,1
         DEFB $FE
PAT5:
         DEFB 16  ; Pattern tempo
             DEFB 1,16
             DEFB 227,30
             DEFB 1,0
             DEFB 227,1
             DEFB 227,30
             DEFB 227,1
             DEFB 1,0
             DEFB 227,30
             DEFB 192,1
             DEFB 192,30
             DEFB 1,30
             DEFB 192,1
             DEFB 171,30
             DEFB 171,30
             DEFB 1,30
             DEFB 171,30
         DEFB $FE
PAT6:
         DEFB 16  ; Pattern tempo
             DEFB 114,16
             DEFB 227,128
             DEFB 114,0
             DEFB 227,128
             DEFB 227,114
             DEFB 227,128
             DEFB 96,0
             DEFB 227,1
             DEFB 192,114
             DEFB 192,128
             DEFB 114,0
             DEFB 192,128
             DEFB 171,114
             DEFB 171,128
             DEFB 1,0
             DEFB 171,1
         DEFB $FE
PAT7:
         DEFB 16  ; Pattern tempo
             DEFB 76,16
             DEFB 86,227
             DEFB 76,0
             DEFB 86,227
             DEFB 76,227
             DEFB 86,227
             DEFB 96,0
             DEFB 1,227
             DEFB 86,192
             DEFB 96,192
             DEFB 114,0
             DEFB 128,192
             DEFB 114,171
             DEFB 96,171
             DEFB 86,0
             DEFB 1,171
         DEFB $FE
PAT8:
         DEFB 16  ; Pattern tempo
             DEFB 76,16
             DEFB 86,227
             DEFB 76,0
             DEFB 86,227
             DEFB 76,227
             DEFB 86,227
             DEFB 96,0
             DEFB 1,227
             DEFB 128,192
             DEFB 114,192
             DEFB 114,0
             DEFB 128,192
             DEFB 114,171
             DEFB 128,171
             DEFB 114,0
             DEFB 1,171
         DEFB $FE
PAT9:
         DEFB 16  ; Pattern tempo
             DEFB 128,16
             DEFB 121,227
             DEFB 114,0
             DEFB 114,227
             DEFB 1,227
             DEFB 114,227
             DEFB 114,0
             DEFB 1,227
             DEFB 128,192
             DEFB 121,192
             DEFB 114,0
             DEFB 114,192
             DEFB 1,171
             DEFB 114,171
             DEFB 114,0
             DEFB 1,171
         DEFB $FE
PAT10:
         DEFB 16  ; Pattern tempo
             DEFB 128,16
             DEFB 121,227
             DEFB 38,0
             DEFB 43,227
             DEFB 57,227
             DEFB 64,227
             DEFB 57,0
             DEFB 64,227
             DEFB 57,192
             DEFB 43,192
             DEFB 38,0
             DEFB 43,192
             DEFB 57,171
             DEFB 64,171
             DEFB 57,0
             DEFB 64,171
         DEFB $FE
PAT11:
         DEFB 16  ; Pattern tempo
             DEFB 64,16
             DEFB 64,227
             DEFB 38,0
             DEFB 43,227
             DEFB 57,227
             DEFB 64,227
             DEFB 57,0
             DEFB 64,227
             DEFB 57,192
             DEFB 43,192
             DEFB 38,0
             DEFB 43,192
             DEFB 57,171
             DEFB 64,171
             DEFB 57,0
             DEFB 64,171
         DEFB $FE
PAT12:
         DEFB 16  ; Pattern tempo
             DEFB 64,16
             DEFB 64,227
             DEFB 1,0
             DEFB 57,227
             DEFB 57,227
             DEFB 1,227
             DEFB 57,0
             DEFB 57,227
             DEFB 1,192
             DEFB 1,192
             DEFB 48,0
             DEFB 1,192
             DEFB 1,171
             DEFB 48,171
             DEFB 1,0
             DEFB 1,171
         DEFB $FE
PAT13:
         DEFB 16  ; Pattern tempo
             DEFB 48,16
             DEFB 1,227
             DEFB 1,0
             DEFB 227,30
             DEFB 227,1
             DEFB 227,30
             DEFB 1,0
             DEFB 227,30
             DEFB 192,1
             DEFB 192,30
             DEFB 1,0
             DEFB 192,30
             DEFB 171,30
             DEFB 171,1
             DEFB 1,30
             DEFB 171,30
         DEFB $FE
PAT14:
         DEFB 16  ; Pattern tempo
             DEFB 1,30
             DEFB 227,30
             DEFB 1,0
             DEFB 227,1
         DEFB $FE
